/* $Id: Bane.java,v 1.4 2007/08/31 01:14:43 mit Exp $ */
/* Bane.java v1.3 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class Bane extends Applet implements AdjustmentListener
{
    private Scrollbar scrP, scrQ;
    int W;
    int H;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());

	Panel p = new Panel();
	p.setLayout(new GridLayout(2,2,0,0));

	scrP = new Scrollbar(Scrollbar.HORIZONTAL,10,1,0,60);
	p.add(scrP);
	scrP.addAdjustmentListener(this);

	p.add(new Label(" : P (Damper)"));

	scrQ = new Scrollbar(Scrollbar.HORIZONTAL,40,1,0,60);
	p.add(scrQ);
	scrQ.addAdjustmentListener(this);

	p.add(new Label(" : Q (Spring)"));

	add(p, "South");
    }
    public void start() {
	W = getSize().width;
	H = getSize().height;
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	repaint();
    }

    public void update(Graphics g) {
	paint(g);
    }
    public void paint (Graphics g) {
	int hx = (int)(H*6/7d);    // Disp.size
	int dh = (int)(H/3d);
	int hw = W/2;
	int hh = hx/2;
	int xofs = 10;
	int t0 = 0;                // ֽ
	int tf = W;                // ǽ
	double dx = tf/(W*10d);
	double y = 2d;             // ®
	double x = 0d;             // Ѱ (0)

	g.setColor(Color.black);
	g.fillRect(0,0,W,H);

	g.setColor(Color.blue);
	g.drawLine(0,hh,W,hh);
	g.drawLine(xofs, 0, xofs, H);

	double p = scrP.getValue()/10d; // ѡ
	double q = scrQ.getValue()/10d; // Хͽ

	g.setColor(Color.red);
	g.drawString("P = "+p, 30, 10);
	g.drawString("Q = "+q, 80, 10);

	double k1, k2, k3, k4, l1, l2, l3, l4;
	g.setColor(Color.green);
	for (int i = t0; i < tf; i++) {
	    g.drawOval(i+xofs, (int)(hh-x*dh), 1,1);

	    k1 = dx * fnk(y);
	    l1 = dx * fnl(y, x, p, q);
	    k2 = dx * fnk(y+l1/2);
	    l2 = dx * fnl((y+l1/2), (x+k1/2), p, q);
	    k3 = dx * fnk(y+l2/2);
	    l3 = dx * fnl((y+l2/2), (x+k2/2), p, q);
	    k4 = dx * fnk(y+l3);
	    l4 = dx * fnl((y+l3), (x+k3), p, q);
	    x += (k1+2*k2+2*k3+k4)/6;
	    y += (l1+2*l2+2*l3+l4)/6;
	}
    }
    public double fnk(double y) {
	return y;
    }
    public double fnl(double y, double x, double p, double q) {
	return -p*y-q*x;
    }
}
